#/bin/sh
#
#   Template to create vitutor.c for a given operating system.  Each
#   operating system is anticipated by passing as $1 a sed script to convert
#   the generic lessons (vitutorj.s1) into OS specific lessons.
#
#   Adding a new lesson set (beyond improving or modifying vitutorj.s1 or
#   vitutorj.s2) requires editing this file.  Adding a lesson set 3, for
#   instance, will mean adding an integer bitmap to lesson_files[] (probably
#   1<<(3-1)), adding a string to lesson_names, and modifying menu_info[].
#   Also, the case statement that updates "selector" will need to handle
#   a new variable.  This should be straight forward to most 'C' programmers.
#
#		modified for japanese version by Takasuka Yoshihiro
#                         E-mail:i04143@sr2.takuma-ct.ac.jp

cat <<EOF >vitutor.c
#include <stdio.h>
#include <errno.h>
/* 
   Files to present for each lesson.   Each number is a 0 relative bitmap
   format--hence 1 --> lesson 1, 2 --> lesson 2, 4 --> lesson 3, 
   1<<(n-1) --> lesson n.  To add a new lesson  add a new entry to the
   lesson_files array.
*/

int lesson_files[] = {
      1,     /* Lesson 1, dump out vitutor.1 */
      1 | 2  /* Lesson 2, needs two files: vitutor.1 and vitutor.2 */
   };
char *lesson_names[] = {"vitutor.1", "vitutor.2"};

char *menu_info[] = {
"`Zbg (25 - 30 )",
"     Lesson  1: ړAIƋNA폜Ƒ}",
"     Lesson  2: IuWFNg R}htH[}bgAAhD",
"     Lesson  3: vbgA㏑AύX",
"     Lesson  4: sAA}b`OAu",
"     Lesson  5: VXeR}hAOt@C̓ǂݍ݂Ə",
"     Lesson  6: s̒ǉAA㏑Aϐ̐ݒ",
"",
"aZbg (40 - 50 )",
"     Lesson  7: ʎwAsẅړAs̘A",
"     Lesson  8: s̃}[LOAp^[}b`O",
"     Lesson  9: Oobt@At@CҏW",
"     Lesson 10: ԍobt@AtB^OAϐ̐ݒ",
"",
"ǂ̃bX܂ (A or B)? "
};
char *s_1[] = {
EOF
sed -f $1 <vitutorj.s1 >>vitutor.c
cat <<EOF >>vitutor.c
0};
char *s_2[] = {
EOF
sed -f $1 <vitutorj.s2 >>vitutor.c
cat <<EOF >>vitutor.c
0};

char **Lessons[] = {s_1, s_2};

# define MENUSIZE (sizeof(menu_info)/sizeof(char **))
extern errno, sys_nerr;
extern char *sys_errlist[];

#define ErrPrint(s1,s2) {\\
fprintf(stderr, "\n%s:: ", sys_errlist[errno]);\\
fprintf(stderr, s1, s2);\\
fprintf(stderr, "\n");}


main()
{
   char ans[10];
   int j, i, selection = -1;
   FILE *lfile; 

   while (selection == -1) {
      printf ("                              Vitutor bXZbg\n");
      for (i = 0; i < MENUSIZE; ++i) {
         printf ("\n   %s", menu_info[i]);
      }
      fgets (ans, 10, stdin);
      switch (*ans) {
      case 'a':
      case 'A':
         selection = 0;
      break;
      case 'b':
      case 'B':
         selection = 1;
      break;
      default:
         printf ("A  BIłB\n");
      }
   }
/* Write out each lesson as needed. */
   for (j = i = 0; i < sizeof (Lessons)/sizeof (char **); ++i) {
      if (lesson_files[selection] & (1 << i)) {
      /* This lesson needs to be written to disk. */
         if ((lfile = fopen (lesson_names[i], "w")) == NULL) {
            ErrPrint("%s I[vł܂\n", lesson_names[i]);
            exit(1);
         }
         while (Lessons[i][j] != 0)
            fprintf (lfile, "%s\n", Lessons[i][j++]);
         j = 0;
         fclose (lfile);
      }
   }
   execlp ("vi", "vi", lesson_names[selection], 0);
   ErrPrint ("sł܂ł\n", (char *)NULL);
   exit (1);
}
EOF
